<?php

namespace Picea\Ui\Component;

use Picea\Ui\Common\UiElement;
use Picea\Extension\Extension;
use Picea\Extension\ExtensionTrait;

class UiMessage extends UiElement implements Extension {
    use ExtensionTrait;

    public string $token = "ui.message";

    public string $tag = "input";

    public array $attributes = [
       'class' => 'ui-message',
    ];

    public function parse(\Picea\Compiler\Context &$context, ?string $arguments, string $token) : string
    {
        return "";
    }
}
