<?php

namespace Picea\Ui\Method;

use Picea\Extension\Extension,
    Picea\Extension\ExtensionTrait;

use Picea\Compiler\Context;

use Picea\Extension\FunctionExtension;
use Psr\Http\Message\ServerRequestInterface;

class Pagination implements Extension, FunctionExtension {
    use ExtensionTrait;

    public array $tokens;

    public string $token;

    public ServerRequestInterface $request;
    
    public function __construct(ServerRequestInterface $request, Context $context) {
        $this->request = $request;
    }

    public function parse(\Picea\Compiler\Context &$context, ?string $arguments, string $token) : string { }


    public function exportFunctions(): array
    {
        return [
            "pagination" => [ $this, 'paginationClass' ]
        ];
    }

    public function paginationClass(string $name, ?string $url = null, ?array $params = null) : PaginationHandler
    {
        return new PaginationHandler($this->request, $name, $url, $params);
    }
}
