<?php

namespace Picea\Ui;

use Picea\Compiler;

class Ui {

    public function registerFormExtension(Compiler $compiler) : self
    {
        $compiler->registerExtension(new Form\UiForm());
        $compiler->registerExtension(new Form\UiInput());
        $compiler->registerExtension(new Form\UiCheckbox());
        $compiler->registerExtension(new Form\UiColor());
        $compiler->registerExtension(new Form\UiDate());
        $compiler->registerExtension(new Form\UiDatetime());
        $compiler->registerExtension(new Form\UiEmail());
        $compiler->registerExtension(new Form\UiFile());
        $compiler->registerExtension(new Form\UiHidden());
        $compiler->registerExtension(new Form\UiNumeric());
        $compiler->registerExtension(new Form\UiPassword());
        $compiler->registerExtension(new Form\UiRadio());
        $compiler->registerExtension(new Form\UiRange());
        $compiler->registerExtension(new Form\UiSearch());
        $compiler->registerExtension(new Form\UiTel());
        $compiler->registerExtension(new Form\UiText());
        $compiler->registerExtension(new Form\UiTextarea());
        $compiler->registerExtension(new Form\UiTime());
        $compiler->registerExtension(new Form\UiUrl());
        $compiler->registerExtension(new Form\UiWeek());
        $compiler->registerExtension(new Form\UiSelect());
        $compiler->registerExtension(new Form\UiImage());

        $compiler->registerExtension(new Component\UiPopup());

        return $this;
    }
}
